﻿using System;

using System.Xml.Linq;

namespace Jp.Co.Atmarkit.Sample.Entity
{
    /// <summary>
    /// ユーザーエンティティです。
    /// ※属性はプロパティ化しておかないとコントロールのItemSourceとして認識してくれません！
    /// </summary>
    public class User 
    {
        /// <summary>名前です。</summary>
        public String Name { get; set;}

        /// <summary>住所です。</summary>
        public String Address { get; set;}

        /// <summary>年齢です。</summary>
        public String Age { get; set;}

        /// <summary>性別です。</summary>
        public String Sex { get; set;}

        /// <summary>
        /// ユーザーを生成します。
        /// </summary>
        /// <param name="user">XML形式のユーザーです。</param>
        /// <returns>Userオブジェクトです。</returns>
        public static User Populate(XElement user)
        {
            // nullの場合はnullを返す
            if(user == null) 
            {
                return null;
            }
        
            User returnValue = new User();
        
            // name
            if(user.Element("name").Value != null) 
            {
                returnValue.Name = user.Element("name").Value;
            }
            
            // sex
            if (user.Element("sex").Value != null)
            {
                returnValue.Sex = user.Element("sex").Value;
            }

            // age
            if (user.Element("age").Value != null)
            {
                returnValue.Age = user.Element("age").Value;
            }

            // address
            if (user.Element("address").Value != null)
            {
                returnValue.Address = user.Element("address").Value;
            }
            
            return returnValue;     
        }
    }
}
